// mid.js 
//

const Cc = Components.classes;
const Ci = Components.interfaces;

// findService = Cc["@mozilla.org/find/find_service;1"].getService(Ci.nsIFindService);

/*   window. "global"  vars  */

locale = "us"; 
progresscounter=0;
midForwardCounter=0;
midBackCounter=-1;
midSaveInTree=true;
midRowCounter=-1;
midFullScreen=false;
midFromRestore=false;
tabIconic=false;
isRunning=false;
homepage="about:blank";
midBrowserStartLocation="http://www.google.com";

midMyPrefB = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefBranch);
midMyPrefS = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService);

/* main */

function midmain(e)
{
    if (isRunning) return;  // called from urlbar as chrome://mid/content
    isRunning=true;

    managePreferences(); 
    setBrowserURL();
    midLoadDicts();
    
    window.addEventListener("load",midMyOnLoad,true);
}



var midWebProgressListener =
  {
    QueryInterface: function(iid) {
    if (iid.equals(Ci.nsIWebProgressListener) ||
        iid.equals(Ci.nsISupportsWeakReference) ||
        iid.equals(Ci.nsISupports))
      return this;
    
     throw Components.results.NS_ERROR_NO_INTERFACE;
  },

    onProgressChange : function (wp, req, cur, max, curtotal, maxtotal) {},
    onStateChange : function (wp, req, state, status) {
      if ((state & Ci.nsIWebProgressListener.STATE_STOP ) && 
	 (state & Ci.nsIWebProgressListener.STATE_IS_NETWORK)){
	 if (progresscounter>0) progresscounter=progresscounter-1;
         if (progresscounter==0) 
	   document.getElementById("mid:stoploadbutton").disabled=true;
      } 
      if ((state & Ci.nsIWebProgressListener.STATE_START ) && 
	 (state & Ci.nsIWebProgressListener.STATE_IS_NETWORK)){
         document.getElementById("mid:stoploadbutton").disabled=false;
	 progresscounter=progresscounter+1;
      }
    },
    onLocationChange : function (wp, req, loc) {},
    onStatusChange : function (wp, req, status, message) {},
    onSecurityChange : function (wp, req, state) {}
  };



function  managePreferences() {

    /* get rid of old-style preferences */
    if (midMyPrefB.getPrefType("extensions.mid.dtype.en_en") == midMyPrefB.PREF_BOOL){
        branch = midMyPrefS.getBranch("extensions.mid.dtype.");
        branch.deleteBranch("");
     }

    /* First run, set default */
    var deftype=
    document.getElementsByTagName("default-dict-type").item(0).getAttribute("label");
    if (midMyPrefB.getPrefType("extensions.mid.dtype."+ deftype) != midMyPrefB.PREF_BOOL){
        midMyPrefB.setBoolPref("extensions.mid.dtype." + deftype, true) ;
    }
} 

function  setBrowserURL(){

    // Started from a browser   
    if ( window.opener && window.opener.content.location.href != "" ){
          midBrowserStartLocation=window.opener.content.location.href; 
          document.getElementById("mid:MainBrowser").setAttribute(
	                        "src",midBrowserStartLocation);
	document.getElementById("mid:Url").value=midBrowserStartLocation;
    }

}



function midMyOnLoad(e)
{
	e.stopPropagation();
}


function midLoadDicts(midlines)
{
   var i,xmlDic, dictType, dictChecked,

    ITomb = new Array();
    DTomb = new Array();

    // clear tabpanels
    var tps=document.getElementById("mid:tabpanels");
    while (tps.hasChildNodes()) {
      try {
        if (tps.firstChild.getAttribute("collapsed")==false)
	    tps.firstChild.removeProgressListener(midWebProgressListener);
      } catch(e) { alert ("removeProgressListener failed") ; } ;
      tps.removeChild(tps.firstChild);
    }

    /* clear tabs */
    var mytabs=document.getElementById("mid:tabs");
    while (mytabs.hasChildNodes()) mytabs.removeChild(mytabs.firstChild);

    for(i=0; (xmlDic=document.getElementsByTagNameNS("http://mid.mozdev.org/dictionaries","dict").item(i));i++)
    {
        dictId      = xmlDic.getAttribute("dictid");
        dictType    = xmlDic.getAttribute("type");
        if (midlines) {
            if (midlines.join().indexOf(dictId)>-1) {
                DTomb.push(midlines.join().indexOf(dictId)/37);
                ITomb[midlines.join().indexOf(dictId)/37]=i;
                dictChecked=false;
            }  else dictChecked=false;
        }
        else {
        if  ( xmlDic.getAttribute("checked") == "true" ) dictChecked=true ; else dictChecked=false  ;
        if (midMyPrefB.getPrefType("extensions.mid."+ dictId + "_checked" ) == midMyPrefB.PREF_BOOL){
           dictChecked = midMyPrefB.getBoolPref("extensions.mid."+ dictId + "_checked" ) ;
        }
        dtchecked = false;
        if (midMyPrefB.getPrefType("extensions.mid.dtype."+ dictType) == midMyPrefB.PREF_BOOL){
            dtchecked = midMyPrefB.getBoolPref("extensions.mid.dtype." + dictType) ;
        }

        if ( dtchecked )  {
            midCreateTab(xmlDic,dictChecked);
         } /* if checked type */
       }
    } // for

    if ( midlines)
        for (var k in DTomb ) {
            xmlDic=document.getElementsByTagNameNS("http://mid.mozdev.org/dictionaries","dict").item(ITomb[k]);
            dictId      = xmlDic.getAttribute("dictid");
            dictType    = xmlDic.getAttribute("type");
            dictChecked = true;
            dtchecked   = true;
            midCreateTab(xmlDic,dictChecked);
        }

     DTomb=null;
     ITomb=null;

     /* Add progress listeners and find first not collapsed */

     var selecteditem=0; 
     var myBrowser;

     for (i=tps.getElementsByTagName("browser").length-1;
           ( myBrowser = tps.getElementsByTagName("browser").item(i) );
	   i--
	 ) {
           if (myBrowser.getAttribute("collapsed")==false) {
             myBrowser.docShell.allowJavascript=true;
             if ( myBrowser.xmlDic.getAttribute("js") == "disabled" ) { 
                  myBrowser.docShell.allowJavascript=false;
             }
             selecteditem=i;
             try {
	         myBrowser.addProgressListener( midWebProgressListener,
		                          Ci.nsIWebProgress.NOTIFY_STATE_NETWORK );
	     } catch(e) { alert ("addProgressListener failed") ; } ;
           } 
     }
     mytabs.selectedIndex=selecteditem;

} 



function midCreateTab(xmlDic,dictChecked) {

    var   newTab, newBrowser;
    newTab=document.createElement("tab");
    newTab.setAttribute("id","tab"+ dictId );
    newTab.setAttribute("context","mid:tabcontextpopup");
    newTab.setAttribute("label",xmlDic.getAttribute("label") );
    /* image on tab */
    newTab.setAttribute("image",xmlDic.getAttribute("fav"));
    newTab.setAttribute("tooltiptext", xmlDic.getAttribute("label") + " : " 
	  + xmlDic.getAttribute("home") );
    newTab.setAttribute("midhome",xmlDic.getAttribute("home"));
	 
    document.getElementById("mid:tabs").appendChild(newTab);
    // newTab.setAttribute("crop","end"); 

    newBrowser    = document.createElement("browser");
    newBrowser.xmlDic = xmlDic;
    newBrowser.setAttribute("onload","alert('lo');");

    newBrowser.setAttribute("id","b"+ dictId );
    if ( ! dictChecked) { 
        newTab.setAttribute("collapsed","true" );
        newBrowser.setAttribute("collapsed","true" );
    }  else {
        newBrowser.setAttribute("type","content-primary");
	newBrowser.setAttribute("context","mid:browsercontextpopup");
        newBrowser.setAttribute("src",xmlDic.getAttribute("home"));
        newBrowser.setAttribute("homepage",xmlDic.getAttribute("home"));
    } //checked dict

    document.getElementById("mid:tabpanels").appendChild(newBrowser);

}; /* function */



function midGetDictionaryPreferences() {

    var midDictArg = new Object;
    
    openDialog("choose_dict.xul","pref",
           "modal=1,dialog=1,chrome=1,centerscreen=1,resizable=0",
		    midDictArg );
    if (midDictArg.mylines) {
        midlines=midDictArg.mylines; delete midDictArg ;
        midLoadDicts(midlines);

    }
    else if (midDictArg.result) {
        delete midDictArg;
        midLoadDicts();
    }

    delete midDictArg ;

}



function midtreepopupshoing(event)
{
   midRowCounter=-1;
   var str_OrigTarget = document.getElementById(document.popupNode.id);
   if (str_OrigTarget.localName == "treechildren")
   {
      //create storage containers for results values
      var obj_Row = new Object;
      var obj_Col = new Object;
      var obj_Child = new Object;
      //find tree holder
      var obj_Tree = document.getElementById('mytree');
      //get cell at x/y coords from tree
      obj_Tree.treeBoxObject.getCellAt(event.clientX, event.clientY, obj_Row, obj_Col, obj_Child);
      //if row < 0, we didn't find the row selected in thalert('1');is tree
       midRowCounter=obj_Row.value ;
    }
     //alert(midRowCounter);
   document.getElementById('mid:treecontextpopup').setAttribute("collapsed","false");
   if (midRowCounter<0) {
   document.getElementById('mid:treecontextpopup').setAttribute("collapsed","true")
   } 
}



function midGetTreeRow(event)
{
   midRowCounter=-1;
   if (event.detail==2) {
      var str_OrigTarget = event.originalTarget;
   } else { 
      var str_OrigTarget = document.getElementById(document.popupNode.id);
   }
   if (str_OrigTarget.localName == "treechildren")
   {
      //create storage containers for results values
      var obj_Row = new Object;
      var obj_Col = new Object;
      var obj_Child = new Object;
      //find tree holder
      var obj_Tree = document.getElementById('mytree');
      //get cell at x/y coords from tree
      obj_Tree.treeBoxObject.getCellAt(event.clientX, event.clientY, obj_Row, obj_Col, obj_Child);
      //if row < 0, we didn't find the row selected in this tree
       midRowCounter=obj_Row.value ;
   }   
       // alert(midRowCounter);
       return midRowCounter;
 
}

function midTreeLookup(event)
{ 
     // midRowCounter is known from popupshowing
     var word=document.getElementsByTagName("treecell").item(midRowCounter*2);
     document.getElementById("mid:searchWord").value=word.getAttribute("label");
     midSaveInTree=false; midmySearch();  midSaveInTree=true;

}

function midTreeFill(event)
{ 
     // midRowCounter is known from popupshowing
     var defi=document.getElementsByTagName("treecell").item(midRowCounter*2+1);

     var defstrbundle=document.getElementById("tree.definition");
     var definition=defstrbundle.getString("tree.definition");

     defi.setAttribute("label",prompt(definition,defi.getAttribute("label")));

}

function midTreeRemoveRow(event){
    mytree=document.getElementById("mytree");
    myoldrowcount=mytree.view.rowCount;
    myrow = document.getElementsByTagName("treecell").item(midRowCounter*2+1);
    myrow.parentNode.removeChild(myrow);
    myrow = document.getElementsByTagName("treecell").item(midRowCounter*2);
    myrow = document.getElementsByTagName("treerow").item(midRowCounter);
    parent=myrow.parentNode;
    parent.removeChild(myrow);
    parent.parentNode.removeChild(parent);
    
   // if (!( midBackCounter < myrow) ) midBackCounter-- ; 
   // else midForwardCounter--; 
}

function midTreeRemoveAllRow(event){
    mytree=document.getElementById("mytreech");
    while (mytree.hasChildNodes()) mytree.removeChild(mytree.firstChild)
}



function midsetValue(event)
{
   if (  event.altKey ) {
     var defi=document.getElementsByTagName("treecell").item(midGetTreeRow(event)*2+1);
     defi.setAttribute("label",prompt("Definition",defi.getAttribute("label"))); // i18n
   }
   else {
     var word=document.getElementsByTagName("treecell").item(midGetTreeRow(event)*2);
     document.getElementById("mid:searchWord").value=word.getAttribute("label");
     midSaveInTree=false; midmySearch();  midSaveInTree=true;
     //  inserted in feb 16
   }
}

function midmainbrowserpopupshoing()
{
if (midGetSelection()==''){
  document.getElementById("mid:mainBCL").setAttribute("disabled","true");
  document.getElementById("mid:mainBCC").setAttribute("disabled","true");
} else {
  document.getElementById("mid:mainBCL").setAttribute("disabled","false");
  document.getElementById("mid:mainBCC").setAttribute("disabled","false");
}
    var mid_mb=document.getElementById("mid:MainBrowser");
      // alert(mid_mb.canGoBack);
    if (mid_mb.canGoBack==false){
       document.getElementById("mid:mainBCB").setAttribute("disabled","true");
    } else { 
       document.getElementById("mid:mainBCB").setAttribute("disabled","false");
    }

    if (mid_mb.canGoForward==false){
       document.getElementById("mid:mainBCF").setAttribute("disabled","true");
    } else { 
       document.getElementById("mid:mainBCF").setAttribute("disabled","false");
    }
}


function midbrowserpopupshoing()
{
//   alert("aaaa"+this.getAttribute("id"));
if (midGetSelection()==''){
  document.getElementById("mid:BCL").setAttribute("disabled","true");
  document.getElementById("mid:BCC").setAttribute("disabled","true");
} else {
  document.getElementById("mid:BCL").setAttribute("disabled","false");
  document.getElementById("mid:BCC").setAttribute("disabled","false");
}
    var myTabPanel=document.getElementById("mid:tabpanels");
    if (myTabPanel.selectedPanel.canGoBack==false){
       document.getElementById("mid:BCB").setAttribute("disabled","true");
    } else { 
       document.getElementById("mid:BCB").setAttribute("disabled","false");
    }

    if (myTabPanel.selectedPanel.canGoForward==false){
       document.getElementById("mid:BCF").setAttribute("disabled","true");
    } else { 
       document.getElementById("mid:BCF").setAttribute("disabled","false");
    }
}

function midContextLookup()
{
 // document.getElementById("mid:searchWord").setAttribute("value",midGetSelection());
 document.getElementById("mid:searchWord").value=midGetSelection();
 midmySearch(); 
}

function midGetSelection()
{
var node = document.popupNode;
var selection = "";
var nodeLocalName = node.localName.toUpperCase();

if ((nodeLocalName == "TEXTAREA") ||
    (nodeLocalName == "INPUT" && node.type == "text")) {
    selection = node.value.substring(node.selectionStart,node.selectionEnd);
}
else {
    var focusedWindow = document.commandDispatcher.focusedWindow;
    selection =
//    focusedWindow.getSelection.call(focusedWindow).toString();
    focusedWindow.getSelection();
}

  return selection.toString(); 
}


//unused
function midCopyText()
{

  const gClipboardHelper =
  Cc["@mozilla.org/widget/clipboardhelper;1"].getService(Ci.nsIClipboardHelper);
  gClipboardHelper.copyString(midGetSelection());
}


function midtabpopupshoing()
{
// alert(document.popupNode.id);
}

function midCloseTab()
{
   var mytab=document.getElementById("mid:tabs");
   var midtab=document.getElementById(document.popupNode.id);
   
   if (midtab.getAttribute("selected","true")) { mytab.advanceSelectedTab(1) };
   var tabid=document.popupNode.id;
   var browserid=tabid.replace("tab","b");
   var mybrowser=document.getElementById(browserid);
   midtab.setAttribute("collapsed","true" );
   mybrowser.setAttribute("collapsed","true" );
   middictId = tabid.replace ("tab", "");
   midMyPrefB.setBoolPref("extensions.mid." + middictId + "_checked", false) ;

}

function midOpenHomePage()
{
 var midtab=document.getElementById(document.popupNode.id);
 window.open(midtab.getAttribute("midhome"));
}

function midConvert(b,w) {

   var cw="";
   var converter = Cc['@mozilla.org/intl/texttosuburi;1']
   		   .createInstance(Ci.nsITextToSubURI);
	
	 try  {
          cw=converter.ConvertAndEscape(b.contentDocument.characterSet,w);
	 } catch (e) { cw=w }

   return cw; 
};



function midmySearch()
{

   var i, url ,smyWord,myBrowser;
   var myWord =document.getElementById("mid:searchWord").value; 
   
//   myWord=myWord.replace(/[\-,'"+!%\/=(),.?:_]*$/g,"");
     myWord=myWord.replace(/['"+!%\\\/=\(\)\[\]\{\},\.\-?:_ <>]*$/g,"");

   if (myWord=='') {return 0 ;}
   document.getElementById("mid:searchWord").value=myWord; 
   var mytree = document.getElementById("mytreech");
   
   for(i=0; (myBrowser=document.getElementsByTagName("browser").item(i));i++)
   { 

      if (myBrowser.getAttribute("collapsed")!="true" 
          && myBrowser.getAttribute("id") != "mid:MainBrowser"){

	 smyWord = midConvert(myBrowser,myWord);
         if ( myBrowser.xmlDic.getAttribute("method") == "POST"){
	    midPostURI(myBrowser,smyWord); 
         } else  if (myBrowser.xmlDic.getAttribute("method")=="func"){
	    searchfunction=myBrowser.xmlDic.getAttribute("function_name");
	    try {
	    eval(searchfunction)(myBrowser,myWord,smyWord);
	    } catch (e) {alert ("Function error:"+searchfunction);}; 
	 } else {
	   url = myBrowser.xmlDic.getAttribute("url");
	   myBrowser.setAttribute("src", url.replace("XXX",smyWord));
	 }; // normal
	   //findService.searchString = myWord;    
           // findService.findNext();
     }; // if
   }; // for
   
//   document.commandDispatcher.focusedWindow.find(myWord);

   document.getElementById("mid:searchWord").focus();
   document.getElementById("mid:searchWord").setSelectionRange(0,document.getElementById("mid:searchWord").textLength);
   midBackCounter++; 
   midupdateImages();

   // don't save it twice in the tree
   midmytree=document.getElementById("mytree"); //var?
   midmytreerow=midmytree.view.rowCount;         //var?
   if ( midmytreerow > 0 ) {
     // Compatibility issues(getcelltext)?
     var col = midmytree.columns ? midmytree.columns["mid:words"] : "mid:words";
     try {
          midmytreecelltext = midmytree.view.getCellText(midmytreerow-1, col  ); 
	} catch (e) {alert(e);}
     if (midmytreecelltext==myWord) return ; // same as the last word
   }
 
   if (! midSaveInTree ) {return};
   saveInHistory(myWord,"");
   
}



function saveInHistory(myWord,myDef){
   // a little bit strange, yes

   var mytree = document.getElementById("mytreech");
   var midmytree=document.getElementById("mytree");
   var midmytreerow=midmytree.view.rowCount;

   var newTreeItem = document.createElement("treeitem");
   var newTreeRow = document.createElement("treerow");
   var newWord = document.createElement("treecell");
   var newDef = document.createElement("treecell");
   
   newWord.setAttribute("label",myWord);
   newWord.setAttribute("editable","false");
   newTreeRow.appendChild(newWord);
   newDef.setAttribute("label",myDef);
   newTreeRow.appendChild(newDef);
   
   newTreeItem.appendChild(newTreeRow);
   mytree.appendChild(newTreeItem);
   
   midmytree.treeBoxObject.ensureRowIsVisible(midmytreerow);

}



function midaboutBox() {

    openDialog("about.xul",
       	"About mid",
	"chrome,resizeable,centerscreen,dialog,min-width=350px");

};



function midshowHomePage(){

    window.open("http://mid.mozdev.org");

}



function midshowDictionaries(){

	var myff = Cc["@mozilla.org/file/directory_service;1"]
		.getService(Ci.nsIProperties)
		.get("ProfD", Ci.nsIFile);

	var ios = Cc["@mozilla.org/network/io-service;1"]
		.getService(Ci.nsIIOService);

	var fileHandler = ios.getProtocolHandler("file")
		.QueryInterface(Ci.nsIFileProtocolHandler);

	var URL = fileHandler.getURLSpecFromFile(myff);

	var fURL= "jar:" +URL +
		"/extensions/{9ef1e09b-d4b2-4a55-ac3e-1cb330546bec}" +
		"/chrome/mid.jar!/content/dictionaries.xml";

	var mURL= "jar:" +URL +
		"/chrome/mid.jar!/content/dictionaries.xml";


	var midBWrapper = new Object;

	midBWrapper.Firefox   = function () { window.open(fURL); };
	midBWrapper.Flock     = function () { window.open(fURL); };
	midBWrapper.Netscape  = function () { window.open(fURL); };
	midBWrapper.SeaMonkey = function () { window.open(mURL); };
 	midBWrapper.mid           = function ()
	{
	    var myff = Cc["@mozilla.org/file/directory_service;1"]
			.getService(Ci.nsIProperties)
			.get("resource:app", Ci.nsIFile);
	    var URL = fileHandler.getURLSpecFromFile(myff);
	    var xURL= URL + "chrome/content/mid/dictionaries.xml";
	    window.open(xURL);
	};

 	
	midBrowserWrapper( midBWrapper );
	
}

function midBrowserWrapper(a){

	var midBrowserName = ""; 

	try {
	    var appInfo = Cc["@mozilla.org/xre/app-info;1"]
              .getService(Ci.nsIXULAppInfo);
	} catch(e) {};

	if ( appInfo ) midBrowserName = appInfo.name ;
        //	alert(midBrowserName);
	switch ( midBrowserName) {
		case "Firefox":		a.Firefox(); break;
		case "Browser":	 	a.Flock(); break; 	// Flock now
		case "Flock":	 	a.Flock(); break; 	// Flock later?
		case "Netscape":	a.Netscape(); break;
		case "SeaMonkey":	a.SeaMonkey(); break;
		case "mid":             a.mid(); break; 	// Xulrunner aka
		default: 	        alert("Sorry, unkown or old browser");
	};

}



function middoSerialize()
{
// this function is not used, as the time being
   var nsIFilePicker = Ci.nsIFilePicker;
   var nsIFileChannel = Ci.nsIFileChannel;
   
   var file = null, fileStream=null;
   
   var fp = Cc["@mozilla.org/filepicker;1"].createInstance (nsIFilePicker);
   fp.init (window, getLocaleString("choose.file"), nsIFilePicker.modeSave);
   fp.appendFilters(nsIFilePicker.filterAll);
   if (fp.show() != nsIFilePicker.returnOK) { return false;}
      file = fp.file;
   fileStream =
   Cc["@mozilla.org/network/file-output-stream;1"].createInstance
   (Ci.nsIFileOutputStream);
   var mytree = document.getElementById("mytree");
   var serializer = new XMLSerializer();
   var treestr = serializer.serializeToString(mytree);
   
   fileStream.init( file, 0x04 | 0x08, 420, 0 );
   serializer.serializeToStream(mytree,fileStream,null);
   localAlert("file.saved",""); 
};



function middoSave()
{

   var conv = Cc["@mozilla.org/intl/scriptableunicodeconverter"].
              createInstance(Ci.nsIScriptableUnicodeConverter);
   conv.charset = "UTF-8";

   var nsIFilePicker = Ci.nsIFilePicker;
   var nsIFileChannel = Ci.nsIFileChannel;
   
   var file = null, fileStream=null; 
   
   var fp = Cc["@mozilla.org/filepicker;1"].createInstance (nsIFilePicker);
   fp.init (window, getLocaleString("choose.file"), nsIFilePicker.modeSave);
   fp.appendFilters(nsIFilePicker.filterAll);
   if (fp.show() == nsIFilePicker.returnCancel) { return false;}
      file = fp.file;
   fileStream = Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);
   var mytree = document.getElementById("mytree");

   try {   
     fileStream.init( file, 0x04 | 0x08| 0x20, 420, 0 );
   } catch(e) {
     if ( e.name == "NS_ERROR_FILE_ACCESS_DENIED" ) localAlert("file.access.denied","");
     else alert("i/o error: " + e.name + "-" + e.message);   
   } 
  

   var i,xmlDic,a2,word,def;
   
   for(i=0; (xmlDic=document.getElementsByTagName("treecell").item(i));i=i+2)
   {
      
      word=xmlDic.getAttribute("label");
      var myTabPanel=document.getElementById("mid:tabpanels");
      myTabPanel.selectedPanel.goBack();
      a2=document.getElementsByTagName("treecell").item(i+1);
      def=a2.getAttribute("label");
      data =conv.ConvertFromUnicode( word + ";" + def + "\n")   
      fileStream.write(data, data.length);
      
   };
   
   fileStream.close();
   localAlert("file.saved",""); 
};



function middoRead()
{
    var conv = Cc["@mozilla.org/intl/scriptableunicodeconverter"].
		createInstance(Ci.nsIScriptableUnicodeConverter);
    conv.charset = "UTF-8"

    var nsIFilePicker = Ci.nsIFilePicker;
    var nsIFileChannel = Ci.nsIFileChannel;
   
    var file = null, fileStream=null, sorstr="" ; 
    var sor = new Array;

    var fp = Cc["@mozilla.org/filepicker;1"].createInstance (nsIFilePicker);
    fp.init (window, getLocaleString("choose.file"), nsIFilePicker.modOpen);
    fp.appendFilters(nsIFilePicker.filterAll);
    if (fp.show() == nsIFilePicker.returnCancel) { return false;}
    file = fp.file;


    var istream = Cc["@mozilla.org/network/file-input-stream;1"]
		.createInstance(Ci.nsIFileInputStream);
    try {	
	istream.init(file, 0x01, 0444, 0);
    } catch(e) {
        if ( e.name == "NS_ERROR_FILE_ACCESS_DENIED" ) localAlert("file.access.denied","");
        else alert("i/o error: " + e.name + "-" + e.message);
    }

    istream.QueryInterface(Ci.nsILineInputStream);

    /* read lines into array */
    var line = {}, lines = [], hasmore;
    do {
        hasmore = istream.readLine(line);
        sorstr=conv.ConvertToUnicode(line.value)
        sor[0]=""; sor[1]="";
        sor = sorstr.split(";");
        saveInHistory ( sor[0], sor[1]); 
        lines.push(line.value); 
    } while(hasmore);

    istream.close();
};



function midallBrowsersStop()
{
  var myBrowser;
  const nsIWebNavigation = Ci.nsIWebNavigation;
  const flags = nsIWebNavigation.STOP_ALL;
  
      for(i=0; (myBrowser=document.getElementsByTagName("browser").item(i));i++)
      {
     	  try {
	    if ( ! myBrowser.collapsed )
               if (myBrowser.getAttribute("id")!="mid:MainBrowser")
		       { myBrowser.webNavigation.stop(flags) } ;
          } catch (e) { alert ( myBrowser.getAttribute("homepage") ) ;}   
     } 

}



function midhistForward()
{
   var myBrowser;
   if ( midForwardCounter >0 ){
  
      for(i=0; (myBrowser=document.getElementsByTagName("browser").item(i));i++)
      {
     	  try {
	    if ( ! myBrowser.collapsed )
             if (myBrowser.getAttribute("id")!="mid:MainBrowser")
	       if (myBrowser.xmlDic.getAttribute("method")=="POST") {
	          if (! ( midForwardCounter < 0) ) {
	  	     word = 
		     document.getElementsByTagName("treecell")
		       .item((midBackCounter+1)*2);
                     midPostURI(myBrowser, 
		         midConvert(myBrowser, word.getAttribute("label")));
		   } 
		 } else
                 if ( myBrowser.webNavigation.canGoForward )
		       { myBrowser.webNavigation.goForward() } ;
          } catch (e) { myDump ( myBrowser.getAttribute("homepage") ) ;
	  }   
     } 
     midBackCounter++;
     midForwardCounter--;
     midupdateImages();
   }

}

function midhistBack()
{
// midmytree=document.getElementById("mytree"); 
// document.getElementById("mid:searchWord").value=word.getAttribute("label");
// if (myBrowser.xmlDic.getAttribute("method")=="POST"){
//            midPostURI(myBrowser,word);

   var myBrowser, word, home;
   if ( midBackCounter > -1 ){

     for(i=0; (myBrowser=document.getElementsByTagName("browser").item(i));i++)
     {
       try {
	  if ( ! myBrowser.collapsed )
            if (myBrowser.getAttribute("id") != "mid:MainBrowser")

	      if (myBrowser.xmlDic.getAttribute("method")=="POST") {
	          if ( midBackCounter == 0) {
		      myBrowser.goHome();
		  } else {
	  	     word = document.getElementsByTagName("treecell").item((midBackCounter-1)*2);
                     midPostURI(myBrowser, 
		       midConvert(myBrowser, word.getAttribute("label")));
		  }
	      } else
              if ( myBrowser.webNavigation.canGoBack )
	         { myBrowser.webNavigation.goBack() }
       } catch (e) { myDump ( myBrowser.getAttribute("homepage") ) ;}   
     }	 
     midForwardCounter++;
     midBackCounter--;
     midupdateImages();
   }
}



function midmainBrowserBack()
{
    var mid_mb=document.getElementById("mid:MainBrowser");
    mid_mb.goBack();  
}



function midmainBrowserForward()
{
    var mid_mb=document.getElementById("mid:MainBrowser");
    mid_mb.goForward();  
}


function midthisBrowserBack()
{
    var myTabPanel=document.getElementById("mid:tabpanels");
    myTabPanel.selectedPanel.goBack();  
}



function midthisBrowserForward()
{
    var myTabPanel=document.getElementById("mid:tabpanels");
    myTabPanel.selectedPanel.goForward();  
}



function midupdateImages()
{
    var b=document.getElementById("back_image");
    var f=document.getElementById("for_image");
	if ( midForwardCounter < 1 )
	   {f.setAttribute("canwalk","false")}
	else 
	   {f.setAttribute("canwalk","true")};
	if ( midBackCounter < 0 ) 
	   {b.setAttribute("canwalk","false")}
	else 
	   {b.setAttribute("canwalk","true")};
}



function midHistView(){

  var mytree=document.getElementById("mytree");
  if (mytree.getAttribute("collapsed")=="true" )
   {
      document.getElementById("mid:viewpopuphistitem").setAttribute("checked","true");
      mytree.setAttribute("collapsed","false" );
      } else {
      document.getElementById("mid:viewpopuphistitem").setAttribute("checked","false");
      mytree.setAttribute("collapsed","true" );
   };
}



function midBrowserView(){
  var midBrSp=document.getElementById("mid:BrowserSplitter");
  var midBr=document.getElementById("mid:BrowserBox");
  if (midBr.getAttribute("collapsed")=="true" )
   {
      document.getElementById("mid:viewpopupbrowseritem").setAttribute("checked","true");
      midBr.setAttribute("collapsed","false" );
      midBrSp.setAttribute("collapsed","false" );
      } else {
      document.getElementById("mid:viewpopupbrowseritem").setAttribute("checked","false");
      midBr.setAttribute("collapsed","true" );
      midBrSp.setAttribute("collapsed","true" );
   };
}



function midBrowserNavigate()
{
	var midUrl=document.getElementById("mid:Url").value;
	var regexp= /^(([^:\/?#]+):)?(\/\/([^\/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;
    	var ar = regexp.exec(midUrl);
	// alert ( ar[0] + "-"  +  ar[1] + "-"  +  ar[2] + "-" ); 

        if ( ! ar[1] ) midUrl="http://" + midUrl;

	document.getElementById("mid:MainBrowser").setAttribute("src", midUrl );
}



function midGetFocus(){
   document.getElementById("mid:searchWord").focus();
}



function midunload(){

    removeEventListener('load',midMyOnLoad,true);
    // save selected later...

}



function midBrowserFullScreen(){

   midFullScreen=!midFullScreen;
   window.fullScreen=!window.fullScreen;

   document.getElementById("mid:viewFullScreen").setAttribute("checked", (midFullScreen) ? "true" : "false" );

   for(i=0; (midmyelement=document.getElementsByTagName("toolbar").item(i));i++){
       midmyelement.setAttribute("collapsed", (midFullScreen) ? "true" : "false" );
       
   }
   for(i=0; (midmyelement=document.getElementsByTagName("statusbar").item(i));i++){
       midmyelement.setAttribute("collapsed", midFullScreen );
       
   }
   for(i=0; (midmyelement=document.getElementsByTagName("menubar").item(i));i++){
     midmyelement.setAttribute("collapsed", midFullScreen );
   } 
   
  
}



function midSaveSession()
{
   var nsIFilePicker = Ci.nsIFilePicker;
   var nsIFileChannel = Ci.nsIFileChannel;
   
   var file = null, fileStream=null; 
   
   var fp = Cc["@mozilla.org/filepicker;1"].createInstance (nsIFilePicker);
   fp.init (window, getLocaleString("choose.file"), nsIFilePicker.modeSave);
   fp.appendFilters(nsIFilePicker.filterAll);

   if (fp.show() == nsIFilePicker.returnCancel) { return false;}
      file = fp.file;
   fileStream =
   Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);
   var mytree = document.getElementById("mytree");
   
   fileStream.init( file, 0x04 | 0x08| 0x20, 420, 0 );
   
   var i,tab,a2,word,def;
   
   for(i=0; ( tb = document.getElementsByTagName("tab").item(i));i++)
   {

      if ( tb.getAttribute("collapsed")==false )
          {
              def=tb.id.replace(/^tab/,"") + ";"+ tb.label;
	      
              fileStream.write(def + "\n", def.length+1 );
          }

   };
   
   fileStream.close();

   midMyPrefB.setComplexValue( "extensions.mid.lastusedsets.1", 
				Ci.nsILocalFile,
				file );

   localAlert("file.saved",""); 
}



function midRestoreSession(filePrefNum)
{
   var def;
   var nsIFilePicker = Ci.nsIFilePicker;
   var nsIFileChannel = Ci.nsIFileChannel;
   
    var file = null, fileStream=null; 
    // alert(filePrefNum);
    // alert(typeof(filePrefNum) );
    if (  typeof(filePrefNum) != 'number' ) {
        var fp = Cc["@mozilla.org/filepicker;1"].createInstance (nsIFilePicker);
        fp.init (window, getLocaleString("choose.file"), nsIFilePicker.modeRead);
        fp.appendFilters(nsIFilePicker.filterAll);
        if (fp.show() == nsIFilePicker.returnCancel) { return false;}
        file = fp.file;
     } else {
         var savedFilesPrefs = midMyPrefS.getBranch("extensions.mid.lastusedsets.");
          if ( !savedFilesPrefs.prefHasUserValue(filePrefNum) ) {
	     localAlert("preference.not.found" , "extensions.mid.lastusedsets." + filePrefNum);
	     return false;
	  };
	 file = savedFilesPrefs.getComplexValue( filePrefNum, Ci.nsILocalFile);
	 if (!file.exists()) { localAlert("file.not.found","");  return false; } 
     }
      
    var is =
    Cc["@mozilla.org/network/file-input-stream;1"].createInstance(Ci.nsIFileInputStream);
  
    try {   
        is.init( file, 1 , 0444 , false  );  
    } catch(e) {
        if ( e.name == "NS_ERROR_FILE_ACCESS_DENIED" ) localAlert("file.access.denied","");
        else alert("i/o error: " + e.name + "-" + e.message);   
	return false;
    } 

    is.QueryInterface(Ci.nsILineInputStream);
    
    // read lines into array
    var midline = {}, midlines = [], hasmore;

    do {
      hasmore = is.readLine(midline)
      def=midline.value.replace(/;.*$/,""); 
      def=def.replace(/(.{37}).*/,"$1") // uuid
      midlines.push(def);
      } while(hasmore);

    is.close();

    if (typeof(arrangeLUFPrefs) == 'function') 
            arrangeLUFPrefs(file);


    midFromRestore=true;   // not used
    midLoadDicts(midlines);

}



function midremoveAllPreferences(){
   branch = midMyPrefS.getBranch("extensions.mid.");
   branch.deleteBranch("");
   localAlert("application.restart","");
}



function localAlert(p,q)
{
  var msbd=document.getElementById(p);
  var ls=msbd.getString(p);
  alert(ls+q);
}



function getLocaleString(lsName){
var  myprop =
     Cc["@mozilla.org/intl/stringbundle;1"].getService(Ci.nsIStringBundleService);

	var mystrings = myprop.createBundle("chrome://mid/locale/mid.properties");
	return  mystrings.GetStringFromName(lsName);
}



function midPostURI(browser, word)
{

	var dataString = browser.xmlDic.getAttribute("inputs").replace("XXX",word);

	var postData = Cc["@mozilla.org/network/mime-input-stream;1"].
        	       createInstance(Ci.nsIMIMEInputStream);

	var stringStream = Cc["@mozilla.org/io/string-input-stream;1"].
	                   createInstance(Ci.nsIStringInputStream);

	stringStream.setData(dataString,-1);
	postData.addHeader("Content-Type", "application/x-www-form-urlencoded");
	postData.addContentLength = true;
	postData.setData(stringStream);

	var url=browser.xmlDic.getAttribute("url");

	browser.webNavigation.loadURI(url,
			 browser.webNavigation.LOAD_FLAGS_NONE,
	                 browser.currentURI ,
			 postData,null);

}



function midFindStringOnPage(){
   var keres = top.document.getElementById("mid:searchWord").value;
   
   if ( document.commandDispatcher.focusedWindow.name=="mid:MainBrowser" ) {
	if ( keres != "") {
           if (! document.commandDispatcher.focusedWindow.find(keres))	
           while ( document.commandDispatcher.focusedWindow.find(keres,
	               	false, true)) 
	   continue;
        }
	return;
   }

   if ( document.getElementById("mid:tabbox") && 
        document.getElementById("mid:tabbox").selectedPanel ) {
        document.getElementById("mid:tabbox").selectedPanel.contentWindow.focus();
	if ( keres != "") {
         if (! document.commandDispatcher.focusedWindow.find(keres))	
             while ( document.commandDispatcher.focusedWindow.find(keres,
	     		false,true))
	     continue;
        }
   }
}



function midFindInNextPage(searchFlag){

    var ti=0, tabbox, op, oo , i;

    if ( document.getElementById("mid:tabbox") && 
        document.getElementById("mid:tabbox").selectedPanel ) {

	tabbox = document.getElementById("mid:tabbox");
	
	op = tabbox.selectedPanel;
        oo = op;
	while ( op ){
	  op = op.nextSibling;
	  if ( ! op ) { 
	     op = tabbox._tabpanels.childNodes.item(0);
	     tabbox.selectedIndex=0
	  } else tabbox.selectedIndex++;	
	  
	  if ( op &&  ( op.id == oo.id ) )  break ;  
	  if ( op && op.collapsed==false )  break ;

	}
	if (searchFlag) midFindInPage();
    }
}



function midFindInPrevPage(searchFlag){
    
    var ti=0, tabbox, op, oo , i;
    
    if ( document.getElementById("mid:tabbox") && 
        document.getElementById("mid:tabbox").selectedPanel ) {

	tabbox = document.getElementById("mid:tabbox");
	ti=tabbox._tabpanels.childNodes.length-1;
	
	op = tabbox.selectedPanel;
        oo = op;
	while ( op ){
	  op = op.previousSibling;
	  if ( ! op ) { 
	     op = tabbox._tabpanels.childNodes.item(ti);
	     tabbox.selectedIndex=ti;
	  } else tabbox.selectedIndex--;	
	  if ( op && op.id == oo.id  )  break ;  
	  if ( op && op.collapsed==false )  break ;
	}
	if (searchFlag) midFindInPage();
    }
}


function midFindInPage(){
   var keres = top.document.getElementById("mid:searchWord").value;
   if ( document.getElementById("mid:tabbox") && 
        document.getElementById("mid:tabbox").selectedPanel ) {
        document.getElementById("mid:tabbox").selectedPanel.contentWindow.focus();
	if ( keres != "") {
           while ( document.commandDispatcher.focusedWindow.find(keres,false,true)) continue;

           // document.commandDispatcher.focusedWindow.find(keres);
        }
	// input mezo? akkor tovbb
	var theItem=document.commandDispatcher.focusedWindow.getSelection();
	if (  theItem == "" ) 
          document.commandDispatcher.focusedWindow.find(keres);	
   }
}



function styleTabs(event) {
    var cButton=event.originalTarget;
    if (cButton.localName != "toolbarbutton") return ; // elsewere on tabs

    var curtab, curpanel, i;
    var mytabs = document.getElementById("mid:tabs");

    for( i = 0; ( curtab = mytabs.getElementsByTagName("tab").item(i) ); i++ ){ 

       curpanel = document.getElementById(curtab.linkedpanel);

       if ( tabIconic ) { 
	  curtab.setAttribute("iconic", "false") }
       else  { 
	  curtab.setAttribute("iconic", "true");
       }
    }
    
    if (tabIconic) cButton.setAttribute("iconic", "false")
    else  cButton.setAttribute("iconic", "true");


    tabIconic = ! tabIconic ; 

}



function myDump(aMessage) {
/*
*  http://kb.mozillazine.org/JavaScript_Console#Logging_custom_messages_in_JavaScript_Console
*/

   var consoleService = Cc["@mozilla.org/consoleservice;1"]
                         .getService(Ci.nsIConsoleService);
   consoleService.logStringMessage("mid: " + aMessage);
}






function midCambFrEn(myBrowser,myWord,smyWord){

	myWord=myWord.toLowerCase();           
	myWord=midStripAccents(myWord);
        var url=myBrowser.xmlDic.getAttribute("url");
        myBrowser.setAttribute("src", url.replace("XXX",myWord));
}



function midStripAccents(str)
{
 var s=str;

 var rExps=[ /[\xC0-\xC2]/g, /[\xE0-\xE2]/g,
             /[\xC8-\xCA]/g, /[\xE8-\xEB]/g,
             /[\xCC-\xCE]/g, /[\xEC-\xEE]/g,
             /[\xD2-\xD4]/g, /[\xF2-\xF4]/g,
             /[\xD9-\xDB]/g, /[\xF9-\xFB]/g,
	     /[\xC7]/g     , /[\xE7]/g    ] ;

 var repChar=['A','a','E','e','I','i','O','o','U','u','C','c'];

 for(var i=0; i<rExps.length; i++)
  s=s.replace(rExps[i],repChar[i]);

 return s;

}



function midOnetRuPl(myBrowser,myWord,smyWord){
	myWord=toUniNumber(myWord);
        var url=myBrowser.xmlDic.getAttribute("url");
        myBrowser.setAttribute("src", url.replace("XXX",myWord));
}

function toUniNumber(s) {
	var c; var o=""; var i=s;
        for( var m=0;i.charAt(m);++m )
          if (
                ( (c=i.charCodeAt(m))<128 && c!=38 ) ||
                (c>=160 && c<=255 &&
                 c!=166 &&
                 c!=173 && c!=178 && c!=179 &&
                 c!=185 && c!=188 && c!=189 &&
                 c!=190 &&
                 c!=208 &&
                 c!=215 &&
                 c!=221 && c!=222 &&
                 c!=240 &&
                 c!=253 && c!=254
                )
          ) o+=i.charAt(m);
          else if (c==38) o+="&";
          else o+="&#"+c+";";
          return escape(o);
}

